'##############################################################################################################################
' General Template for testing and own Applications / Allgemeine Vorlage zum Testen und Programmieren
'##############################################################################################################################

'Settings
Const Number_of_scans_analog = 2                            '***change***Here you have to adjust how many Values you want to log!
Const Start_test = "placet experiri"
Const Version_data = "V23.2.11"
Const Chip_m256 = 1                                         '0 for M128; 1=M256

'Notes:
'Mglichkeiten mit den Testprogramm
'==================================
'Testen und Schalten aller Ausgnge
'Testen aller analogen und digitalen Eingnge
'Datum/Uhrzeit-Eingabe (Men 7) als Beispiel
'Daten-Eingabe bers Gert (Men 8) als Beispiel
'Bedienung und Daten-Eingabe ber den PC (z.B. Dialer von der CD oder ber ein Terminal-Programm, S fr Starten, E fr Ende, ansonsten 0-9 und * und #-Tasten)
'Parameter-bertragung auf den PC in eine Text-Datei (Dialer von der CD, dort Daten, Parameter holen). Es wurden erst mal 50 Integer Daten vorgesehen
'Parameter-bertragung von einer Textdatei auf dem PC in die Metamorphose (Dialer von der CD, dort Daten, Parameter senden).
'Status Ein/Ausgnge und Messwerte zyklisch senden zum Dialer (PC-Software). Start ber den Dialer (Anzeige alle Daten) oder Senden von "S" und "O".
'Messwerte senden nach Logview (Freeware zur Kurvendarstellung); Start ber den Dialer (Daten, Daten nach Logview) oder Senden von "S" und "U".

'Aufbau Text-Datei fr den Datenaustausch mit dem PC
'Beliebiger Text, dann : und dann der Wert (alles nach dem : wird gesendet!). Siehe Beispiel im Anhang
'

'Menu 7: Input Date/Time
'Menu 8: Input and Display Data to and from EEPROM from Byte 102...; Input allways Integer
'Menu 9: Test and switch Input/Output
'
'You can also test with a Terminal-Program (Strg + T in Bascom with 19200 Bd). Press "S" to Start and "#" and "*" for to navigate and "R" to finish
'You can use the Dialer to Remote-Control and to Upload / Download Parameter
'Outputs are Reset automatic, you need only to set the Output in the Program
'
'Digital Inputs:
'############**
'1:Terminal 47+48 = Input_1 =
'2:Terminal 47+49 = Input_2 =
'3:Terminal 50+51 = Input_3 =
'4:Terminal 50+52 = Input_4 =
'5:Terminal 53+54 = Input_5 =
'6:Terminal 53+55 = Input_6 =
'7:Terminal 56+57 = Input_7 =
'8:Terminal 56+58 = Input_8 =

'Analog Group 1:
'###############
'1:CPU-Pin 21 = Terminal 59+60 = Power-Supply voltage = Getadc(0)    'optional Battery voltage
'2:CPU-Pin 22 = Terminal 45+46 = regulated Output-voltage = Getadc(1)         'optional Output voltage
'3:CPU-Pin 23 = Terminal 59+61 = Analog_3 = Getadc(2)
'4:CPU-Pin 24 = Terminal 62+63 = Analog_4 = Getadc(3)
'5:CPU-Pin 25 = Terminal 62+64 = Analog_5 = Getadc(4)
'6:CPU-Pin 26 = Terminal 71+72 = Analog_6 = Getadc(5)
'7:CPU-Pin 27 = Terminal 71+73 = Analog_7 = Getadc(6)
'8:CPU-Pin 28 = Program-Selector = Getadc(7)

'Analog Group 2 (with Multiplexer to Pin 28):
'##########################################**
'9 = Terminal 74+75 = Analog_9
'10= Terminal 74+76 = Analog_10
'11= Terminal 77+78 = Analog_11
'12= Terminal 77+79 = Analog_12
'13= Terminal 80+81 = Analog_13
'14= Terminal 80+82 = Analog_14
'15= Terminal internal (NiCd-Voltage) = Analog_15

'Output Group 1:
'###############
'Porta.0 CPU-Pin 1 Terminal 12/24V: 35+ / 36- Transisor 1 (only 12V/24V):
'Porta.1 CPU-Pin 2 Terminal 12/24V: 30+/34-; Bridge 31-35 Terminal 110/220 V: 30+31 = Relay 2:
'Porta.2 CPU-Pin 3 Terminal 12/24V: 24+/25-; Bridge 21-22 Terminal 110/220 V: 22+24 = Relay 3:
'Porta.3 CPU-Pin 4 Terminal 12/24V: 23+/25-; Bridge 21-22 Terminal 110/220 V: 22+23 = Relay 4:
'Porta.4 CPU-Pin 5 Terminal 12/24V: 8+ / 9-; Bridge 11-12 Terminal 110/220 V: 8+12  = Relay 5:
'Porta.5 CPU-Pin 6 Terminal 12/24V: 7+ / 9-; Bridge 11-12 Terminal 110/220 V: 7+12  = Relay 6:
'Porta.6 CPU-Pin 7 Terminal 12/24V: 2+ / 4-; Bridge 1-3   Terminal 110/220 V: 2+3   = Relay 7:
'Porta.7 CPU-Pin 8 internal Alarm-Beeper:

'Output Group 2:
'###############
'Portb.7 = CPU-Pin 117 = Output 8 PWM-Output Transisor
'Portg.1 = CPU-Pin 134 = Output 9 Transisor
'Portg.3 = CPU-Pin 118 = Output_10 Transisor
'Portg.4 = CPU-Pin 119 = Output_11 Transisor
'Porte.7 = CPU-Pin 109 = Output_12 Transisor
'Portg.2 = CPU-Pin 143 = Output_13 Transisor / Phase-Loop-Control
'Portd.7 = CPU-Pin 108 = Output_14 Input/Output no Trans.wired only R= 330 Ohms
'Portb.0 = CPU-Pin 47 = Internal Relay 1A (NimH-charge)
'Porte.5 = CPU-Pin 107 = LED-Light
'Porte.2 = CPU-Pin 104 = High Current Puls MOSFET

'Timer
'############
'Timer 0 RTC Time (for Date and Time and more)
'Timer 1 DTMF(OC1A=15)+ Noise-Detector(T1,31); M256= PWM out
'Timer 2 PWM Load 8 bit, Phase-Loop; OCR2A PB4 and OCR2B; TCCR2A = &B10000001; TCCR2B = &B00000111;  Ocr2a = Value
'Timer 3 Counter 1 (Phase-Loop-Control 0-crossing detection)
'Timer 4 Phase Loop Control
'Timer 5 Counter 2

'Interrrupt
'##########
'Portb.1 = Pin 40 = PCINT1: Interrupt Phase Loop control 0-crossing detection

'Analog Compare
'##############
'single Voltage:
'Porte3 = Pin 105 = Analog Compare AIN1 and Internal 1.1V or 2,56 V Voltage Reference
'dual Voltage:
'Porte.2 = Pin 104 = Analog Compare AIN0
'Porte.3 = Pin 105 = Analog Compare AIN1

'Counter/Frequence
'#################
'Portd.6 = Pin 37 = Counter 1 in (Timer 1)
'Porte.6 = Pin 36 = Counter 2 in (Timer 3)

'serial Port
'###########
'COM 1 load Program, Remote-Control by PC, Modem, GSM-Modem (RxD = Port e.0 = Pin 112; TxD = Port e.1 = Pin 113)
'COM 2: ELV-Radio Receiver: (RxD = Portd.2 = Pin 45; TxD = Portd.3 = Pin 44)

'Radio-Sensors:
'###############
'ELV Wind_speed
'Elv Temp
'Elv Humidity
'Elv Rain

'Phase.Loop-Control
'###################
'Portg.2 = Pin 143 = Output
'Portb.1 = Pin 40 = Input Phase Loop control

'Telephone
'===========
'PortB.5 = Pin 115 =PWM1:DTMF out
'PortC.7 = Pin 16 Relay call Telephone

'I2C
'####
'PD0 Pin 125 SCL/int SCL/Radio_Clock
'PD1 Pin 126 SDA/int SDA/Radio Data

'Free
'#####
'Porte.3 Pin 105 Analog Comparator
'Porte.4 Pin 106 PWM Output B T3/int  (Sensor active for Irrigate)
'Portd.7 Pin 108 free Output 14 etc
'PortG.2 Pin 143 free Output_13/Load 6/Phase Loop

'Data in EEPROM:
'###############
'1 =
'2 =
'3 =
'4 =
'5 =
'6 =
'7 =
'8 =
'9 =
'10 =
'11 =
'12 =
'13 =
'14 =
'15 =
'16 =
'17 =
'18 =
'19 =
'20 =
'21 =
'22 =
'23 =
'24 =
'25 =
'26 =
'...
'102 : 1. Scan-Time Data-Log to internal Flash (Data modified by Menu 8)
'104 : 2 .Send Data to Logview; Data modified by Menu 8
'106 : 3 .Data modified by Menu 8
'108 : 4 .Data modified by Menu 8
'1010: 5 .Data modified by Menu 8
'1012: 6 .Data modified by Menu 8
'1014: 7 .Data modified by Menu 8
'1016: 8 .Data modified by Menu 8
'1018: 9 .Data modified by Menu 8
'1020: 10.Data
'1022: 11.Data
'1024: 12.Data
'1026: 13.Data
'1028: 14.Data
'1030: 15.Data
'1032: 16.Data
'1034: 17.Data
'1036: 18.Data

'LCD Menus:
'#########
'Basic-Menu
'1.
'2.
'3.
'4.
'5.
'6.Gimmik
'7.Time Display and Input
'8.Parameters
'9. Status and Switch Input/Output

'Data to Dispay on PC (corresponds to name in Visual Basic)
'#########################################################
'Analog_1:
'Analog_2:
'Analog_3:
'Analog_4:
'Analog_5:
'Analog_6:
'Analog_7:
'Analog_8:
'Analog_9:
'Analog_10:
'Analog_11:
'Analog_12:
'Analog_13:
'Analog_14:
'Analog_15:

'Free_1:
'Free_2:
'Free_3:
'Free_4:
'Free_5:
'Free_6:
'Free_7:
'Free_8:
'Free_9:
'Free_10:
'Free_11:
'Free_12:
'Free_13:
'Free_14:
'Free_15:
'Free_16:

'30 = Pointer Phonenumber
'31-44 = Telefonnummer 1
'45-59 = Telefonnummer 2

'from 800 I/O-Text
'from 1600 Measurement Values

' ### Port-Definition ###
Dim Lcd_port As Byte
Dim Port1 As Bit                                            'Hupe laut / Verfahren Grundschalter
Dim Port2 As Bit                                            'Relay 7 / Leermeldung Khl-Wasser
Dim Port3 As Bit                                            'Batterie aus /Tr-Diebstahlschutz
Dim Port4 As Bit                                            'Solar aus
Dim Port5 As Bit                                            'Relay 3
Dim Port6 As Bit                                            'Relay 4
Dim Port7 As Bit                                            'Relay 5
Dim Port8 As Bit                                            'Relay 6
Dim Lcd_rs As Bit
Dim Lcd_rw As Bit
Dim Port11 As Bit
Dim Port12 As Bit

Dim Ad1 As Integer                                          '12 Volt
Dim Ad2 As Integer                                          'Output voltage
Dim Ad3 As Integer                                          '
Dim Ad4 As Integer                                          '
Dim Ad5 As Integer                                          '
Dim Ad6 As Integer                                          '
Dim Ad7 As Integer                                          'Solarzelle Diebstahlschutz
Dim Ad8 As Integer

Dim Relay_1 As Bit
Dim Relay_2 As Bit                                          'Relay Batterie voll
Dim Relay_3 As Bit                                          '
Dim Relay_4 As Bit
Dim Relay_6 As Bit
Dim Relay_5 As Bit
Dim Relay_7 As Bit
Dim Fkt1 As Bit                                             'Funktion Kochzeit
Dim Fkt4 As Bit                                             'Funktion Spannungsanzeige
Dim Fkt5 As Bit                                             'Funktion
Dim Fkt6 As Bit                                             'Funktion
Dim Fkt7 As Bit                                             'Funktion Uhreingabe
Dim Fkt2 As Bit                                             'Funktion Schaltuhr
Dim Fkt9 As Bit                                             'Funktion Handebene
Dim Meldung_aktiv As Bit                                    'Hupe aktiv
Dim Fkt3 As Bit                                             'Funktion Count_down
Dim Stelle_1 As Bit
Dim Beeper As Bit
Dim Fkt8 As Bit                                             'Umschaltung Sekunden zhlen fr Pasteurisierung
Dim Keyb_flanke As Bit
Dim No_comma As Bit                                         'kein Komma!
Dim Disp_fkt9 As Bit                                        'Nur Anzeige Handebene
Dim Tel_nr As Bit                                           '
Dim Mobile_aktiv As Bit

Dim Sec_alt As Byte                                         'Second-counter Flanke
Dim Keyb As Integer                                         'Input keyboard
Dim Lcd_param As Byte                                       'Daten an LCD
Dim Pointer_eeprom As Byte
Dim Value As Integer                                        'Schmier-Flag byte 23+24
Dim M_second As Byte
Dim Second As Byte                                          'Sekunden-Zhler Flanke
Dim Minute As Byte                                          'Sekunden-Zhler Flanke
Dim Hour As Byte                                            'Sekunden-Zhler Flanke
Dim Temp As Integer                                         'Schmier-Flag 2
Dim Temp1 As Byte                                           'Schmier-Flag 3
Dim Temp2 As Integer
Dim Temp3 As Integer
Dim Temp_b1 As Byte
Dim Temp_b2 As Byte
Dim Temp_b3 As Byte
Dim Temp_b4 As Byte
Dim Temp_b5 As Byte
Dim Remote_key As Byte
Dim Remote_key_old As Byte
Dim Delay As Byte
Dim S As String * 6
Dim Programm_selector As Byte

Dim U_ausg As Integer                                       'AD[2]    'Regelbare Spannung
Dim Wahlschalter As Integer                                 'AD[8]
Dim Switch_input_block As Byte
Dim Negative_number As Bit
Dim Year As Byte
Dim Month As Byte
Dim Mday As Byte
Dim Week_day As Byte
Dim Day As Byte
Dim Analog_block As Byte
Dim Temp_lcd As Integer
Dim No_print_seriell As Bit
Dim Simu As Bit
Dim Send_flash_to_logview As Bit
Dim Data_direct_to_pc As Bit
Dim Display_time_grid As Bit
Dim Two_comma As Bit
Dim Eight_bit_value_neg As Bit
Dim Display_submenues As Byte
Dim Display_info As Byte
Dim Lcd_display_position As Byte                            'used internally by LCD_Display routine..
Dim Lcd_disp_char As String * 1                             'used internally by LCD_Display routine..
Dim Lcd_display_string As String * 16                       'string to be displayed,  set this and the 'Gosub Lcd_Display...
Dim Lcd_display_pad_with_spaces As Bit                      '=0 no change; =1 pad 'lcd_display_string' with spaces to make it 16 characters long before
Dim Gosub_analog_extended As Bit
Dim Pwm_port As Bit
Dim Nimh_load_rel As Bit
Dim Output_9 As Bit
Dim Output_10 As Bit
Dim Output_11 As Bit
Dim Output_12 As Bit
Dim Output_13 As Bit
Dim Output_14 As Bit
Dim Analog_9 As Integer
Dim Analog_10 As Integer
Dim Analog_11 As Integer
Dim Analog_12 As Integer
Dim Analog_13 As Integer
Dim Analog_14 As Integer
Dim Analog_15 As Integer
Dim Input_1 As Bit                                          '
Dim Input_2 As Bit                                          '
Dim Input_3 As Bit                                          '
Dim Input_4 As Bit                                          '
Dim Input_5 As Bit                                          '
Dim Input_6 As Bit                                          '
Dim Input_7 As Bit
Dim Input_8 As Bit                                          '
Dim Counter_1 As Word
Dim Counter_2 As Word
Dim Delay_on As Byte
Dim Timer_1_sec As Byte
Dim Max_value As Byte
Dim English As Bit
Dim Delay_next_key As Byte
Dim Prg_switch_remote As Byte
Dim Data_pointer As Byte
Dim Time_no_seriell_pc As Byte
Dim Timer_2_sec As Bit
Dim No_data_lcd_in_sec_loop As Bit
Dim No_display_basic_menu As Bit
Dim Sending_os_data_active As Bit
Dim Vb_process_display As Bit
Dim Output_digital_1 As Byte
Dim Output_digital_2 As Byte
Dim Inputs As Byte
Dim Count_data_to_pc As Byte
Dim Block_count_send As Word
Dim Last_value As Bit

Dim End_pointer_flash As Integer
Dim Zeiger_ram_end As Integer
Dim Eeprom_second_time As Bit
Dim Write_ram As Bit
Dim Eeprom_full As Bit
Dim Zeiger_ram As Integer
Dim Ram_second_time As Bit
Dim Zeiger_flash As Integer
Dim Ram_full As Bit
Dim Minute_byte As Byte
Dim Day_logview As Byte
Dim Month_logview As Byte
Dim Hour_logview As Byte
Dim Min_logview As Byte
Dim Sec_logview As Byte
Dim Time_logview As Long

'### ASCII-Codes ###
Const A_ = &H41
Const B_ = &H42
Const C_ = &H43
Const D_ = &H44
Const E_ = &H45
Const F_ = &H46
Const G_ = &H47
Const H_ = &H48
Const I_ = &H49
Const J_ = &H4A
Const K_ = &H4B
Const L_ = &H4C
Const M_ = &H4D
Const N_ = &H4E
Const O_ = &H4F
Const P_ = &H50
Const Q_ = &H51
Const R_ = &H52
Const S_ = &H53
Const T_ = &H54
Const U_ = &H55
Const V_ = &H56
Const W_ = &H57
Const X_ = &H58
Const Y_ = &H59
Const Z_ = &H5A

Const Aa_ = &H61
Const Ae_ = &HE1
Const Bb_ = &H62
Const Cc_ = &H63
Const Dd_ = &H64
Const Ee_ = &H65
Const Ff_ = &H66
Const Gg_ = &H67
Const Hh_ = &H68
Const Ii_ = &H69
Const Jj_ = &H6A
Const Kk_ = &H6B
Const Ll_ = &H6C
Const Mm_ = &H6D
Const Nn_ = &H6E
Const Oo_ = &H6F
Const Oe_ = &HEF
Const Pp_ = &H70
Const Qq_ = &H71
Const Rr_ = &H72
Const Ss_ = &H73
Const Tt_ = &H74
Const Uu_ = &H75
Const Ue_ = &HF5
Const Vv_ = &H76
Const Ww_ = &H77
Const Xx_ = &H78
Const Yy_ = &H79
Const Zz_ = &H7A

Const Null_ = &H30
Const Eins_ = &H31
Const Zwei_ = &H32
Const Drei_ = &H33
Const Vier_ = &H34
Const Fuenf_ = &H35
Const Sechs_ = &H36
Const Sieben_ = &H37
Const Acht_ = &H38
Const Neun_ = &H39

Const Leerz = &H20
Const Minus = &H2D
Const Null = &H30
Const Gleich = &H3D
Const Punkt = &H2E
Const Hochz = &HDF
Const Doppelp = &H3A
Const Strich = &H2D
Const Ausr = &H21                                           'Ausrufungszeichen
Const Fragez = &H3F
Const Prozent = &H25
Const Schraegstrich = &H2F

Const Lcd_cursoroff = &B00001100                            'kein Cursor sichtbar
Const Lcd_cursoron = &B00001110                             'Unterstrich (nicht blinkend)
Const Lcd_cursorblock = &B00001101                          'groer Block, blinkend
Const Lcd_cursorline = &B00001110                           'Unterstrich (nicht blinkend)
Const Lcd_cursorblink = &B00001111                          'Unterstrich/Block, abwechselnd blinkend
Const Lcd_displayoff = &H08                                 'Display ausschalten
Const Lcd_displayon = &H0C                                  'Display einschalten
Const Lcd_cursorleft = &H10                                 'Cursor ein Zeichen nach links
Const Lcd_cursorright = &H14                                'Cursor ein Zeichen nach rechts
Const Lcd_displayleft = &H18                                'ges. Display ein Zeichen nach links
Const Lcd_displayright = &H1C                               'ges. Display ein Zeichen nach rechts

Const Lcd_gotoline1 = &H80                                  'Cursor in Zeile 1
Const Lcd_gotoline2 = &HC0                                  'Cursor in Zeile 2

Const Blank = &H20                                          'Zeichen ' '
Const Char_rufzeichen = &H21                                'Zeichen !
Const Char_anfzeichen = &H22                                'zeichen ""
Const Char_doppelkreuz = &H23                               'Zeichen #
Const Char_dollar = &H24                                    'Zeichen $
Const Char_prozent = &H25                                   'Zeichen %
Const Char_ampersand = &H26                                 'Zeichen &
Const Char_apostroph = &H27                                 'Zeichen '
Const Char_klammerauf = &H28                                'Zeichen (
Const Char_klammerzu = &H29                                 'Zeichen )
Const Char_stern = &H2A                                     'Zeichen *
Const Char_plus = &H2B                                      'Zeichen +
Const Char_komma = &H2C                                     'Zeichen ,
Const Char_minus = &H2D                                     'Zeichen -
Const Char_punkt = &H2E                                     'Zeichen .
Const Char_schraegstrich = &H2F                             'Zeichen /
Const Char_doppelpunkt = &H3A                               'Zeichen :
Const Char_eckklammauf = &H5B                               'Zeichen [
Const Char_eckklammzu = &H5D                                'Zeichen ]
Const Char_caret = &H5E                                     'Zeichen ^
Const Char_unterstrich = &H5F                               'Zeichen _
Const Char_geschwklammauf = &H7B                            'Zeichen {
Const Char_vertstrich = &H7C                                'Zeichen |
Const Char_geschwklammzu = &H7D                             'Zeichen }
Const Char_pfeilrechts = &H7E                               'Pfeil nach rechts
Const Char_pfeillinks = &H7F                                'Pfeil nach links
Const Char_spot = &HA5                                      'Zeichen ''
Const Char_horstrich = &HB0                                 'Zeichen '-'
Const Char_grad = &HDF                                      'Zeichen 
Const Char_mykro = &HE4                                     'Zeichen 
Const Char_unendlich = &HF4                                 'Zeichen 
Const Char_ohm = &HF5                                       'Zeichen 
Const Char_block = &HFF                                     'Zeichen ''

' ### Initialisierungen ###
#if Chip_m256 = 0                                           '
Dim Data_log(2020) As Byte                                  'Array of x Bytes
Const Pointer_end_ram = 2000
Const Preset_pointer_flash = 800
#else
Dim Data_log(5820) As Byte                                  '***M256 Array of 1800  alt 3610 alt 3410
Const Pointer_end_ram = 5800                                '***M256
Const Preset_pointer_flash = 1600
#endif

$crystal = 4000000

Gosub Lcd_init                                              'Initialisierung LCD

'////////////////////////ADC-Port /////////////
Portf = 0                                                   'ADC-Port
Config Adc = Single , Prescaler = Auto                      ', Reference = Avcc
Start Adc                                                   'ADC starten
'///////////////////// COM-Settings/////////////////////////////////////////
$baud = 19200 : Open "com1:" For Binary As #1               'Communication
Config Serialin = Buffered , Size = 254                     '60
Config Serialout = Buffered , Size = 254                    '60
Print #1 , "Com1"

Config Com2 = Dummy , Synchrone = 0 , Parity = None , Stopbits = 1 , Databits = 8 , Clockpol = 0
$baud1 = 19200 : Open "com2:" For Binary As #2              'Communication
Config Serialin1 = Buffered , Size = 50
Print #2 , "Com2"

'///////////////////////////////////////////////////////////////////////////////
Echo Off                                                    'no echo from seriell!
Print #1 , "ATS0=1"                                         'Modem: Set number of rings before automatically answering the call
Print #1 , "AT^Srtc=0,4"                                    'Set the ringing tone off
Print #1 , "ate0"                                           'echo Modem off

'///////////////// RTC Clock Timer 0 //////////////////////// do not delete!
Config Timer0 = Timer , Prescale = 256                      '
On Ovf0 Tim0_isr                                            'Define the ISR handler
Enable Timer0
Enable Interrupts

'////////////////// Counter Timer 1+3 ////////////////////
Porte.6 = 1                                                 'Pull-up aktivieren
Config Pine.6 = Input
Config Timer3 = Counter , Edge = Rising

Portd.6 = 1                                                 'Pull-up aktivieren
Config Pind.6 = Input
Config Timer1 = Counter , Edge = Rising

'//////////////// Analog-MUX = PB2, PD4, PD5 for Analog in 9-15 /////////////////
Config Pinb.2 = Output : Portb.2 = 0
Config Pind.4 = Output : Portd.4 = 0
Config Pind.5 = Output : Portd.5 = 0

Print #1 , "ATS0=1"                                         'Modem auf antwort-Modus
Remote_key = Inkey(#1)
Remote_key_old = Remote_key

'################ 'I2C-Routine ######################
'$lib "I2C_TWI.LBX"
''Configure for software SPI
'Portb.4 = 1
'Config Pinb.4 = Input                                       'Miso
'Config Pinb.3 = Output                                      'MOSI
'Config Pinb.6 = Output                                      'CLK
'Config Ping.0 = Output                                      'CS
''                    MISO           MOSI             Cs             CLK
'Config Spi = Soft , Din = Pinb.4 , Dout = Portb.3 , Ss = Portg.0 , Clock = Portb.6
'Spiinit
'
' Config Scl = Portd.0 //'I2C Master?
' Config Sda = Portd.1
' I2cinit                                                    ' we need to set the pins in the proper state
'
' Config Twislave = &H70 , Btr = 1 , Bitrate = 100000 'I2C Slave?

'################### Output ##############################
Config Pinb.0 = Output
Config Ping.1 = Output : Config Ping.3 = Output : Config Ping.4 = Output : Config Ping.2 = Output
Config Pind.7 = Output
Config Pine.7 = Output

' ### Cycle Programm ###
Loop:                                                       'here fast Program can be realized
Gosub Modem_call
Gosub Read_log_and_send
#if Chip_m256 = 0                                           '
If Remote_key = 123 Then Goto &HFC00                        'Upload new Programm
#else
If Remote_key = 123 Then Goto &H1FC00                       'M256
#endif
Gosub Keyboard

If Mobile_aktiv = 0 And Vb_process_display = 0 And Data_direct_to_pc = 0 Then
 Count_data_to_pc = 0 : Block_count_send = 0
Else
 Gosub Data_to_pc
End If
 Stop Adc                                                   'for Power-Save
 Idle
Start Adc

If Gosub_analog_extended = 1 Then Gosub Analog_extended
Gosub Sectic                                                'Zeitscheibe Sekunde
Goto Loop

'############### time slice Second; here most program should be realized ####################
Sectic:
If Second = Sec_alt Then Return
Sec_alt = Second
If Delay_on < 255 Then Incr Delay_on
If Delay_on < 255 And Fkt7 = 1 Then Gosub Start_date_time_logview

Delay_next_key = 0
Incr Count_data_to_pc

Gosub Eingaenge
Gosub Counter_fast
Gosub Analog_werte
Gosub Program_switch
Gosub Load_from_flash

Temp_b1 = Second Mod 3 : If Temp_b1 = 0 Then Toggle Timer_2_sec       '3 sec on/off
Timer_1_sec = Second Mod 2


If Meldung_aktiv = 0 And No_data_lcd_in_sec_loop = 0 Then
If Fkt1 = 1 Then Gosub Display_fkt1                         'Eingabe Max-Zeit Pumpen
If Fkt2 = 1 Then Gosub Display_fkt2                         'Schaltuhr
If Fkt3 = 1 Then Gosub Display_fkt3
If Fkt4 = 1 Then Gosub Display_fkt4
If Fkt5 = 1 Then Gosub Display_fkt5
If Fkt6 = 1 Then Gosub Display_fkt6                         'Anzeige Nachfhrung
If Fkt7 = 1 Then Gosub Display_fkt7
If Fkt8 = 1 Then Gosub Display_fkt8                         'Mobile_aktiv = 1 And
If Disp_fkt9 = 1 And Display_submenues = 0 Then Gosub Display_output       'Anzeige Output 2
If Disp_fkt9 = 1 And Display_submenues = 1 Then Gosub Display_fkt9_2       'Anzeige Output 2
If Disp_fkt9 = 1 And Display_submenues = 2 Then Gosub Display_fkt9a       'Analog 1
If Disp_fkt9 = 1 And Display_submenues = 3 Then Gosub Display_fkt9a2       'Analog 2
If Disp_fkt9 = 1 And Display_submenues = 4 Then Gosub Display_fkt9b       'Anzeige Eingnge
End If
No_data_lcd_in_sec_loop = 0                                 'for LCD-character no jam

Gosub Time_date
Gosub Collect_io_info
Gosub Write_log_to_memory                                   'for analog-Values to log
Gosub Output                                                'Ausgnge ansteuern
Gosub Grundmenue                                            'Anzeige Display Grundfunktionen
Return

'################## Time-slice all Minute ###################
Time_min:

Return
'################### here your Programs can be located #######################
'See below for the Menu-Displays etc




















'################## serial functions ########################
Modem_call:
Remote_key = Inkey(#1)                                      'from serial

If Remote_key = "S" Then                                    'Start Serial communication
 Mobile_aktiv = 1 : End If

If Remote_key = "R" Then                                    'Reset Serial communication
  Mobile_aktiv = 0 : End If

Temp1 = 102 : Temp2 = 202                                   'Parameters 1-x up/download (102...202 = 50 Parameter)
If Remote_key = "V" And Mobile_aktiv = 1 Then
 Clear Serialout : Waitms 1500 : Gosub Load_flash_to_file_on_hd : End If       'Upload
If Remote_key = "W" And Mobile_aktiv = 1 Then Gosub Get_data_for_flash       'download data to flash

If Remote_key = "O" And Mobile_aktiv = 1 Then Vb_process_display = 1       'Display in Process-View

If Remote_key = "U" And Mobile_aktiv = 1 Then               'Data direct for Logging
  Data_direct_to_pc = 1 : Vb_process_display = 0 : Mobile_aktiv = 0 : End If       'Direct send of Data
Return

'#################### analog Data to PC (Dailer and Logview) ############################
Data_to_pc:
If Mobile_aktiv = 0 And Vb_process_display = 0 And Data_direct_to_pc = 0 Then Return
If Vb_process_display = 1 Then
 If Count_data_to_pc = 4 Or Count_data_to_pc = 5 Then Mobile_aktiv = 0 : End If

If Count_data_to_pc < 5 Then
 Block_count_send = 0 : Sending_os_data_active = 0 : Return : End If

Incr Block_count_send
If Block_count_send > 100 And M_second < 30 Then Block_count_send = 0

No_comma = 0

Select Case Block_count_send
'$1;1;;;;;;21,0;;;;;;;;55;;;;20,8;50;1,6;0;0;0 Open Format of Logview
Case 1:

If Data_direct_to_pc = 0 Then
 Waitms 200
 Print #1 , "S_" : Waitms 100
Else
 Print #1 , "$1;1;;" ; : Block_count_send = 13              'don't send I/O-Status
End If
'$1;1;; ;0;;;;;;
Case 3:
If Meldung_aktiv = 1 Then                                   'Display that there ia Alarm
 Value = Programm_selector + 101
Else
 Value = Programm_selector + 1
End If
Print #1 , Value

If Vb_process_display = 0 And Block_count_send < 45 Then Block_count_send = 46       'goto end

Case 6:
Mobile_aktiv = 0 : Sending_os_data_active = 1               'no other Data send to PC
Value = Output_digital_1 + 1000 : Print #1 , Value

Case 9:
Value = Output_digital_2 + 1000 : Print #1 , Value

Case 12:
Value = Inputs + 1000 : Print #1 , Value

'################### here you can list your Analog Data you want to view in Dialer or Logview ###################
Case 15:																										'here Data to be send to Logview in VB: Analog_1_S
Value = Ad1 : No_comma = 0 : Gosub Send_value_to_serial                  

Case 18:                                                    'in VB: Analog_2_S
Value = Ad2 : No_comma = 0 :  Gosub Send_value_to_serial

Case 21:                                                    'in VB: Analog_3_S
Value = Ad3 : No_comma = 0 : Gosub Send_value_to_serial

Case 24:                                                    'in VB: Analog_4_S
Value = Ad4 : No_comma = 0 : Gosub Send_value_to_serial

Case 27:                                                    'in VB: Analog_5_S
Value = Ad5 : No_comma = 0 : Gosub Send_value_to_serial

Case 30:                                                    'in VB: Analog_6_S
Value = Ad6 : No_comma = 0  : Gosub Send_value_to_serial

Case 33:                                                    'in VB: Analog_7_S
Value = Ad7 : No_comma = 0 : Gosub Send_value_to_serial

Case 36:                                                    'in VB: Analog_8_S
'Value = counter_1 : No_comma = 0 :  Gosub Send_value_to_serial

Case 39:                                                    'in VB: Analog_9_S
'Value = counter_2 : No_comma = 0 :  Gosub Send_value_to_serial

Case 42:                                                    '
'Gosub Send_value_to_serial

Case 45:                                                    '
'Gosub Send_value_to_serial



If Data_direct_to_pc = 1 Then Last_value = 1

Case 48:
End_data_to_pc:
If Data_direct_to_pc = 0 Then
 Print #1 , "E_"                                            'If Vb_process_display = 0 Then
  Count_data_to_pc = 0
 No_display_basic_menu = 1
 Mobile_aktiv = 1
 Sending_os_data_active = 0
Else
 Printbin #1 , 13                                           ' CR ""
 Printbin #1 , 10                                           'LF
End If

End Select
Return

Collect_io_info:
Output_digital_1 = 0
If Relay_1 = 1 Then Output_digital_1.0 = 1
If Relay_2 = 1 Then Output_digital_1.1 = 1
If Relay_3 = 1 Then Output_digital_1.2 = 1
If Relay_4 = 1 Then Output_digital_1.3 = 1
If Relay_5 = 1 Then Output_digital_1.4 = 1
If Relay_6 = 1 Then Output_digital_1.5 = 1
If Relay_7 = 1 Then Output_digital_1.6 = 1
If Beeper = 1 Then Output_digital_1.7 = 1

Output_digital_2 = 0
If Output_9 = 1 Then Output_digital_2.0 = 1
If Output_10 = 1 Then Output_digital_2.1 = 1
If Output_11 = 1 Then Output_digital_2.2 = 1
If Output_12 = 1 Then Output_digital_2.3 = 1
If Output_13 = 1 Then Output_digital_2.4 = 1
If Output_14 = 1 Then Output_digital_2.5 = 1
If Nimh_load_rel = 1 Then Output_digital_2.6 = 1
If Pwm_port = 1 Then Output_digital_2.7 = 1

Inputs = 0
If Input_1 = 1 Then Inputs.0 = 1
If Input_2 = 1 Then Inputs.1 = 1
If Input_3 = 1 Then Inputs.2 = 1
If Input_4 = 1 Then Inputs.3 = 1
If Input_5 = 1 Then Inputs.4 = 1
If Input_6 = 1 Then Inputs.5 = 1
If Input_7 = 1 Then Inputs.6 = 1
If Input_8 = 1 Then Inputs.7 = 1
Return


'################################### Write Data to Flash #############################################################
Write_log_to_memory:
'Scan-Time Data-Recorder
Readeeprom Value , 102 : Temp_b1 = Value : If Temp_b1 = 0 Then Return       'Scan-Time Data-Recorder
If Temp_b1 >= 60 And Temp_b1 < 100 Then Temp_b1 = 59        '> 60 sek does not work
If Value > 100 Then Temp_b1 = Value - 100
If Value > 200 Then Temp_b1 = Value - 200
Temp_b2 = Second Mod Temp_b1
If Value < 100 And Temp_b2 = 0 Then Goto To_ram
Temp_b2 = Minute_byte Mod Temp_b1
If Value >= 100 And Value < 200 And Second = 10 And Temp_b2 = 0 Then Goto To_ram
Temp_b2 = Hour Mod Temp_b1
If Value > 200 And Second = 10 And Minute = 1 And Temp_b2 = 0 Then Goto To_ram
Return

To_ram:
If Ram_full = 1 Then Goto To_eeprom
If Zeiger_ram < 1 Then Zeiger_ram = 1                       'Start-Wert ab 1
If Zeiger_ram > Pointer_end_ram Then                        'was there a fill-up?

  Ram_full = 1 : Ram_second_time = 1 : Eeprom_full = 0 : Zeiger_ram = 0 : Zeiger_flash = Preset_pointer_flash : Goto To_eeprom : End If

Write_ram = 1 : Gosub Log_data
Return

To_eeprom:
If Zeiger_flash < Preset_pointer_flash Then Zeiger_flash = Preset_pointer_flash
If Zeiger_flash >= 4000 Then                                'was there a fill-up?
  Eeprom_full = 1 : Eeprom_second_time = 1 : Ram_full = 0 : Zeiger_ram = 0 : Zeiger_flash = Preset_pointer_flash : Goto To_ram : End If

Write_ram = 0 : Gosub Log_data
Return

Log_data:
'################# here you give the Values you want to log to the internal RAM / Flash ############################################
Value = 456 : Gosub Write_ram                               '***change adapt your Values to log here **********************
Value = 789 : Gosub Write_ram                               '***change adapt your Values to log here **********************
'Value = Ad3 : Gosub Write_ram                               '***change adapt your Values to log here **********************
'Value = Ad4 : Gosub Write_ram                               '***change adapt your Values to log here **********************
'Value = Ad5 : Gosub Write_ram                               '***change adapt your Values to log here **********************
'Value = Ad6 : Gosub Write_ram                               '***change adapt your Values to log here **********************
Return

Write_ram:
If Write_ram = 0 Then                                       'Write_Flash?
 Writeeeprom Value , Zeiger_flash : Incr Zeiger_flash : Incr Zeiger_flash : Return : End If

Temp3 = Value
Shift Temp3 , Right , 8 : Temp_b1 = Temp3 : Temp3 = Value : Shift Temp3 , Left , 8 : Shift Temp3 , Right , 8 : Temp_b2 = Temp3       '16 bit to 2 Bytes
Data_log(zeiger_ram) = Temp_b1                              '1.Byte
Incr Zeiger_ram
Data_log(zeiger_ram) = Temp_b2                              '2.Byte
Incr Zeiger_ram
Return

'################################### Read Data from Flash #############################################################
Read_log_and_send:
If Remote_key <> "L" And Send_flash_to_logview = 0 Then Return       'L gesendet?
If Zeiger_ram <= 1 Then Ram_second_time = 0 : Zeiger_ram_end = Zeiger_ram       'Save Ende-zeiger
If Ram_second_time = 0 Then Zeiger_ram = 1                  'Start-Adr

End_pointer_flash = Zeiger_flash                            'Ende-zeiger Flash
If Eeprom_second_time = 0 Then Zeiger_flash = Preset_pointer_flash       'STart-Adr

'data_header:
If Send_flash_to_logview = 0 Then
If English = 0 Then Print #1 , "Messwerte" Else Print #1 , "Measured Values"
Waitms 50
If English = 0 Then Print #1 , " Datum: " ; Else Print #1 , " Date: ";
If Month < 10 Then Print #1 , "0" ; : Print #1 , Month ; : Print #1 , ".";
If Day < 10 Then Print #1 , "0" ; : Print #1 , Day ; : Print #1 , "  ";

If English = 0 Then Print #1 , " Zeit: " ; Else Print #1 , " Time: ";
If Hour < 10 Then Print #1 , "0" ; : Print #1 , Hour ; : Print #1 , ":";
If Minute < 10 Then Print #1 , "0" ; : Print #1 , Minute :
Waitms 50

No_comma = 0
Gosub Print_header_data
End If

Loop_read_ram:
If Zeiger_ram < 1 Then Zeiger_ram = 1                       'reasonable values

If Ram_full = 0 And Ram_second_time = 0 And Eeprom_second_time = 0 And End_pointer_flash <= Preset_pointer_flash Then       'No data in Flash
 If Zeiger_ram >= Zeiger_ram_end Or Zeiger_ram > Pointer_end_ram Then Goto Loop_read_ram_end : End If       'Ende?

If Zeiger_ram > Pointer_end_ram Then                        'now read Flash
Zeiger_ram = 1 : Zeiger_flash = Preset_pointer_flash : Ram_full = 0 : Eeprom_second_time = 0 : Goto Loop_read_flash : End If

Gosub Print_logview_header

For Temp_b3 = 1 To Number_of_scans_analog                   '
 Temp_b1 = Data_log(zeiger_ram) : Temp2 = Temp_b1           'Value 1.2....
 Incr Zeiger_ram
 Temp_b2 = Data_log(zeiger_ram) : Temp3 = Temp_b2 : Shift Temp2 , Left , 8 : Value = Temp2 Or Temp3 : Gosub Print_log
 Incr Zeiger_ram
Next
Gosub Print_new_line
Goto Loop_read_ram

Loop_read_ram_end:
Gosub Print_end

Gosub Start_date_time_logview
Return

'##################### Date Time for Logview #################################
Start_date_time_logview:
Day_logview = Day
Month_logview = Month
Hour_logview = Hour
Min_logview = Minute
Sec_logview = Second
Time_logview = 0
Return

Count_day_time_logview:
Readeeprom Value , 102                                      'Scan-Time Data-Recorder
Temp_b1 = Value
If Temp_b1 < 100 Then Time_logview = Time_logview + Temp_b1

If Temp_b1 > 100 And Temp_b1 < 200 Then                     'in minutes
 Temp_b1 = Temp_b1 - 100 : Temp = Temp_b1 * 60 : Time_logview = Time_logview + Temp : End If

If Temp_b1 > 200 Then
 Temp_b1 = Temp_b1 - 200 : Temp = Temp_b1 * 3600 : Time_logview = Time_logview + Temp : End If
Return

'#################################### Read from Flash ############################################################
Loop_read_flash:
If Zeiger_flash < Preset_pointer_flash Then Zeiger_flash = Preset_pointer_flash       'reasonable values

If Ram_full = 0 And Ram_second_time = 0 Then                'No data in Flash
 If Zeiger_flash >= End_pointer_flash Or Zeiger_flash > 4000 Then Goto Loop_read_flash_end : End If       'Ende?

If Zeiger_flash > 4000 Then
'Print #1, "now RAM"
Eeprom_full = 0 : Zeiger_ram = 1 : Zeiger_flash = Preset_pointer_flash : Eeprom_second_time = 0 : End_pointer_flash = Preset_pointer_flash : Ram_second_time = 0 : Goto Loop_read_ram : End If

'Read_eeprom:                                                '1.Value
Gosub Print_logview_header
For Temp_b3 = 1 To Number_of_scans_analog
 Readeeprom Value , Zeiger_flash : Gosub Print_log
 Incr Zeiger_flash : Incr Zeiger_flash
Next
Gosub Print_new_line                                        'new line
Goto Loop_read_flash

Loop_read_flash_end:
Gosub Print_end
Return

Print_logview_header:
Temp_b4 = Number_of_scans_analog

'The Timestamp (if given by your device) should be given in seconds. Always start at 0 !
Gosub Count_day_time_logview
If Send_flash_to_logview = 1 Then
Print #1 , "$1;1;";
Print #1 , Time_logview;
Print #1 , ";" ; : End If
Return

Print_log:
No_comma = 0 : Gosub Print_value : If Send_flash_to_logview = 0 Then Print #1 , "  " ; Else Print #1 , ";";
Return

Print_new_line:
If Send_flash_to_logview = 0 Then
 Print " "
 Else
 Print "0";                                                 'new line
 Printbin #1 , 13                                           ' CR ""
 Printbin #1 , 10                                           'LF
 Waitms 50
End If
Waitms 150                                                  '40
Return

Print_end:
If Send_flash_to_logview = 0 Then Print #1 , "End"
Temp = 0 : Writeeeprom Temp , 104                           'Reset Data Send to Logview
Gosub Display_fkt8
Zeiger_ram = 1
Zeiger_flash = Preset_pointer_flash
Ram_full = 0
Ram_second_time = 0
Eeprom_full = 0
Eeprom_second_time = 0
Return

Print_header_data:
Print "T in";                                               '***change here you give the Text for the 1.value in the Head-Line of the Log-File
Waitms 40

Print "(C) ";                                              '***change here you give the Unit for the 1.value in the Head-Line of the Log-File
Waitms 40

Print "T out";                                              '***change here you give the Text for the 2.value in the Head-Line of the Log-File
Waitms 40

Print "(C) ";                                              '***change here you give the Unit for the 2.value in the Head-Line of the Log-File
Waitms 40

'Print "T in"; '***change here you give the Text for the 3.value in the Head-Line of the Log-File
'Waitms 40
'
'Print "(C) ";'***change here you give the Unit for the 3.value in the Head-Line of the Log-File
'Waitms 40

Print " "
Return

Load_from_flash:
' here you can load Preset-Values from Flash to RAM
Send_flash_to_logview = 0 : Readeeprom Temp , 104
If Temp = 1 Then
 Send_flash_to_logview = 1 : Temp = 0 : Writeeeprom Temp , 104       'Reset Data Send to Logview
Lcd_param = 1 : Gosub Lcd_gotoline
Lcd_display_string = "Start Time Log:" : Gosub Lcd_display

Lcd_param = 2 : Gosub Lcd_gotoline
Value = Day_logview : No_comma = 1 : Gosub Write_value
Lcd_display_string = ":" : Gosub Lcd_display

Value = Month_logview : No_comma = 1 : Gosub Write_value
Lcd_display_string = " " : Gosub Lcd_display

Value = Hour_logview : No_comma = 1 : Gosub Write_value
Lcd_display_string = ":" : Gosub Lcd_display

Value = Min_logview : No_comma = 1 : Gosub Write_value
Lcd_display_string = ":" : Gosub Lcd_display

Value = Sec_logview : No_comma = 1 : Gosub Write_value
Lcd_display_pad_with_spaces = 1 : Lcd_display_string = " " : Gosub Lcd_display
Meldung_aktiv = 1                                           'show until reset
Wait 3
End If
Return


'#################### LCD Basic Menu #################################
Grundmenue:
If Fkt1 = 1 Or Fkt2 = 1 Or Fkt3 = 1 Or Fkt4 = 1 Or Fkt5 = 1 Or Fkt6 = 1 Or Fkt7 = 1 Or Fkt8 = 1 Or Disp_fkt9 = 1 Then Return       'andere FKT angew?

Lcd_param = 1 : Gosub Lcd_gotoline                          '1.Zeile des Displays wird aktiviert
Lcd_display_string = "Prog-Switch:" : Lcd_display_pad_with_spaces = 0 : Gosub Lcd_display
Value = Programm_selector : No_comma = 1 : Gosub Write_value
Lcd_display_string = " " : Lcd_display_pad_with_spaces = 1 : Gosub Lcd_display

Lcd_param = 2 : Gosub Lcd_gotoline                          '1.Zeile des Displays wird aktiviert
Lcd_display_string = "7=Time;8=Data"
If Timer_2_sec = 0 Then Lcd_display_string = "9=Test"
Lcd_display_pad_with_spaces = 1 : Gosub Lcd_display
Gosub Line_feed
Return

'#################### Function Keyboard ##########################
Keyboard:
Config Pinc.4 = Output : Portc.4 = 1                        'Tastatur aktiv setzen
Porta = 0 : Portc.0 = 0 : Portc.1 = 0 : Portc.2 = 0 : Portc.3 = 0
Config Porta = Input
Config Pinc.0 = Input : Config Pinc.1 = Input : Config Pinc.2 = Input : Config Pinc.3 = Input
Port1 = 0 : Port2 = 0 : Port3 = 0 : Port4 = 0 : Port5 = 0 : Port6 = 0 : Port7 = 0 : Port8 = 0
Lcd_rs = 0 : Lcd_rw = 0 : Port11 = 0 : Port12 = 0

If Mobile_aktiv = 1 Then
Keyb = 255                                                  'check Data from seriell for keyboard-action
If Remote_key >= 48 And Remote_key < 58 Then Keyb = Remote_key - 48       'with Modem
If Remote_key = 111 Or Remote_key = 13 Or Remote_key = 35 Then Keyb = 11       'entspricht Zeichen # als o = 111
If Remote_key = 122 Or Remote_key = 27 Or Remote_key = 42 Then Keyb = 10       'entspricht Zeichen * als z = 122

If Remote_key = "A" Then Prg_switch_remote = 1
If Remote_key = "B" Then Prg_switch_remote = 2
If Remote_key = "C" Then Prg_switch_remote = 3
If Remote_key = "D" Then Prg_switch_remote = 4
If Remote_key = "G" Then Prg_switch_remote = 5
If Remote_key = "H" Then Prg_switch_remote = 6
If Remote_key = "I" Then Prg_switch_remote = 7
If Remote_key = "J" Then Prg_switch_remote = 8
If Remote_key = "K" Then Prg_switch_remote = 9
If Remote_key = "P" Then Prg_switch_remote = 10
If Remote_key = "M" Then Prg_switch_remote = 11
If Remote_key = "N" Then Prg_switch_remote = 12

Remote_key = 0
If Keyb <> 255 And Delay_next_key = 0 And Mobile_aktiv = 1 Then       'Key from seriell
  Delay_next_key = 1 : Goto Aktiv : End If
End If
Gosub Tastatur_input                                        'Tastatur abfragen
Keyb = 255
If Port1 = 1 Then Keyb = 6
If Port2 = 1 Then Keyb = 3
If Port3 = 1 Then Keyb = 11                                 'key #
If Port4 = 1 Then Keyb = 9
If Port5 = 1 Then Keyb = 5
If Port6 = 1 Then Keyb = 2
If Port7 = 1 Then Keyb = 0
If Port8 = 1 Then Keyb = 8
If Lcd_rs = 1 Then Keyb = 4
If Lcd_rw = 1 Then Keyb = 1
If Port11 = 1 Then Keyb = 10                                'key *
If Port12 = 1 Then Keyb = 7

If Keyb = 255 Then Return                                   'Flanke keyboard
Aktiv:
Keyb_flanke = 0
If Fkt1 = 1 Or Fkt2 = 1 Or Fkt3 = 1 Or Fkt4 = 1 Or Fkt5 = 1 Or Fkt6 = 1 Or Fkt7 = 1 Or Fkt8 = 1 Or Disp_fkt9 = 1 Then Goto K00

'here keyboard-Functions in the Basic-Menu

K00:
'Alarm off with any key
'if meldung_aktiv = 1 then   'im Grundmenu?
'     meldung_aktiv = 0   : End if

K001:
If Keyb = 10 Then Goto Reset
If Fkt1 = 1 Then Goto Eing_1
If Fkt2 = 1 Then Goto Eing_2
If Fkt3 = 1 Then Goto Eing_3
If Fkt4 = 1 Then Goto Eing_4
If Fkt5 = 1 Then Goto Eing_5
If Fkt6 = 1 Then Goto Eing_6
If Fkt7 = 1 Then Goto Eing_7
If Fkt8 = 1 Then Goto Eing_8
If Disp_fkt9 = 1 Then Goto Eing_9

'##################### Submenu 1 ######################
'Menu 1
Key1:
If Keyb <> 1 Then Goto Key2
Fkt1 = 1 : Lcd_param = &B00000001 : Gosub Lcd_writecmd      'Delete Display
Display_fkt1:
Lcd_display_string = "Menu 1" : Lcd_display_pad_with_spaces = 1 : Gosub Lcd_display
Gosub Line_feed                                             'for Display on PC
Return

'Input Data
Eing_1:
No_data_lcd_in_sec_loop = 1                                 'for LCD-character no jam
Return

'##################### Submenu 2 ######################
Key2:
If Keyb <> 2 Then Goto Key3
Fkt2 = 1 : Lcd_param = &B00000001 : Gosub Lcd_writecmd      '
Display_fkt2:
Lcd_display_string = "Menu 1" : Lcd_display_pad_with_spaces = 1 : Gosub Lcd_display
Gosub Line_feed                                             'for Display on PC
Return

'Input Data
Eing_2:
No_data_lcd_in_sec_loop = 1                                 'for LCD-character no jam

Return

'##################### Submenu 3 ######################
Key3:
If Keyb <> 3 Then Goto Key4
Fkt3 = 1 : Lcd_param = &B00000001 : Gosub Lcd_writecmd      'Display lschen
Display_fkt3:
Lcd_display_string = "Menu 3" : Lcd_display_pad_with_spaces = 1 : Gosub Lcd_display
Gosub Line_feed                                             'for Display on PC
Return

'Eingabe fkt3
Eing_3:
No_data_lcd_in_sec_loop = 1                                 'for LCD-character no jam

Return

'##################### Submenu 4 ######################
Key4:
If Keyb <> 4 Then Goto Key5
Fkt4 = 1 : Lcd_param = &B00000001 : Gosub Lcd_writecmd      'Display loeschen
Display_fkt4:
Lcd_display_string = "Menu 4" : Lcd_display_pad_with_spaces = 1 : Gosub Lcd_display
Gosub Line_feed                                             'for Display on PC
Return

Eing_4:
No_data_lcd_in_sec_loop = 1                                 'for LCD-character no jam

Return

'##################### Submenu 5 ######################
Key5:
If Keyb <> 5 Then Goto Key6
Fkt5 = 1 : Lcd_param = &B00000001 : Gosub Lcd_writecmd      'Display loeschen
Display_fkt5:
Lcd_display_string = "Menu 5" : Lcd_display_pad_with_spaces = 1 : Gosub Lcd_display
Gosub Line_feed                                             'for Display on PC
Return

Eing_5:
No_data_lcd_in_sec_loop = 1                                 'for LCD-character no jam
Return

'##################### Submenu 6 ######################
Key6:
If Keyb <> 6 Then Goto Key7
Fkt6 = 1 : Lcd_param = &B00000001 : Gosub Lcd_writecmd      'Display loeschen
Display_fkt6:
  Lcd_param = &H91 : Gosub Lcd_writecmd                     '1. Zeile, 18. Zeichen
   Lcd_param = Char_unterstrich : Gosub Lcd_writechar       'Zeichen ausgeben
  Lcd_param = Char_unterstrich : Gosub Lcd_writechar        'Zeichen ausgeben
  Lcd_param = Char_unterstrich : Gosub Lcd_writechar        'Zeichen ausgeben
  Lcd_param = Char_schraegstrich : Gosub Lcd_writechar      'Zeichen ausgeben
  Lcd_param = Char_caret : Gosub Lcd_writechar              'Zeichen ausgeben
  Lcd_param = Char_caret : Gosub Lcd_writechar              'Zeichen ausgeben
  Lcd_param = Char_rufzeichen : Gosub Lcd_writechar         'Zeichen ausgeben
  Lcd_param = Char_unterstrich : Gosub Lcd_writechar        'Zeichen ausgeben
  Lcd_param = Char_unterstrich : Gosub Lcd_writechar        'Zeichen ausgeben

  Lcd_param = &HD0 : Gosub Lcd_writecmd                     '2. Zeile, 17. Zeichen
  Lcd_param = Char_klammerauf : Gosub Lcd_writechar         'Zeichen ausgeben
  Lcd_param = Char_unterstrich : Gosub Lcd_writechar        'Zeichen ausgeben
   Lcd_param = O_ : Gosub Lcd_writechar                     'Zeichen ausgeben
  Lcd_param = Char_unterstrich : Gosub Lcd_writechar        'Zeichen ausgeben
  Lcd_param = Char_unterstrich : Gosub Lcd_writechar        'Zeichen ausgeben
  Lcd_param = Char_unterstrich : Gosub Lcd_writechar        'Zeichen ausgeben
  Lcd_param = Char_unterstrich : Gosub Lcd_writechar        'Zeichen ausgeben
  Lcd_param = Char_unterstrich : Gosub Lcd_writechar        'Zeichen ausgeben
  Lcd_param = O_ : Gosub Lcd_writechar                      'Zeichen ausgeben
  Lcd_param = Char_unterstrich : Gosub Lcd_writechar        'Zeichen ausgeben
  Lcd_param = Char_klammerzu : Gosub Lcd_writechar          'Zeichen ausgeben
  Lcd_param = Char_unterstrich : Gosub Lcd_writechar        'Zeichen ausgeben
  Lcd_param = Char_punkt : Gosub Lcd_writechar              'Zeichen ausgeben
   Lcd_param = Char_spot : Gosub Lcd_writechar              'Zeichen ausgeben
  Lcd_param = Char_grad : Gosub Lcd_writechar               'Zeichen ausgeben

    Lcd_param = Lcd_displayleft : Gosub Lcd_writecmd        'Display nach links
Gosub Line_feed                                             'for Display on PC
Return

Eing_6:
No_data_lcd_in_sec_loop = 1                                 'for LCD-character no jam
Return

'##################### Submenu 7 Input Time ######################
Key7:
If Keyb <> 7 Then Goto Key8                                 '
Fkt7 = 1 : Lcd_param = &B00000001 : Gosub Lcd_writecmd      'Display lschen
Display_fkt7:
    If Switch_input_block > 3 Then Switch_input_block = 0
    Lcd_param = 1 : Gosub Lcd_gotoline                      '2.Line LCD anw.
'    If Switch_input_block = 4 Then
'    Lcd_display_string = "W-day(Mo=1):" : If English = 0 Then Lcd_display_string = "W-Tag(Mo=1):"
'    Lcd_display_pad_with_spaces = 0 : Gosub Lcd_display
'    Value = Week_day : No_comma = 1 : Gosub Write_value :
'    Lcd_display_string = "   " : Gosub Lcd_display : Goto Fkt7_line_2 : End If

    Lcd_display_string = "Time:" : If English = 0 Then Lcd_display_string = "Zeit:"
    Gosub Lcd_display
    If Mobile_aktiv = 1 And Switch_input_block = 0 Then Gosub Write_fragez
    Value = Day : No_comma = 1 : Gosub Write_value          'Anzeige Uhrzeit Monat
    Lcd_display_string = "." : Gosub Lcd_display
    If Mobile_aktiv = 1 And Switch_input_block = 1 Then Gosub Write_fragez
    Value = Month : No_comma = 1 : Gosub Write_value        'Anzeige Uhrzeit Tag
    Lcd_display_string = " " : Gosub Lcd_display
    If Mobile_aktiv = 1 And Switch_input_block = 2 Then Gosub Write_fragez
     Value = Hour : No_comma = 1 : Gosub Write_value        'Anzeige Uhrzeit hour
      Lcd_display_string = ":" : Gosub Show_blank : Gosub Lcd_display
    If Mobile_aktiv = 1 And Switch_input_block = 3 Then Gosub Write_fragez
    Value = Minute : No_comma = 1 : Gosub Write_value       'minute
     Gosub Delete_rest_of_display

Fkt7_line_2:
    Lcd_param = 2 : Gosub Lcd_gotoline                      '2.Line LCD
    Value = U_ausg : Gosub Write_value
    Lcd_display_string = "V " : Gosub Lcd_display

Lcd_param = &B00001111 : Gosub Lcd_writecmd                 'Cursor flashin
Lcd_param = &H85
If Switch_input_block = 1 Then Lcd_param = &H88             'Cursor on position x
If Switch_input_block = 2 Then Lcd_param = &H8B             'Cursor on position x
If Switch_input_block = 3 Then Lcd_param = &H8E             'Cursor on position x
'If Switch_input_block = 4 Then Lcd_param = &HCF             'Cursor on position x
Gosub Lcd_writecmd
Gosub Line_feed
Return

'Input Time
Eing_7:
No_data_lcd_in_sec_loop = 1                                 'for LCD-character no jam

If Keyb = 11 Then                                           'Zeichen #?
 Stelle_1 = 0 : Incr Switch_input_block : Display_info = 0 : Goto Display_fkt7 : End If
Select Case Switch_input_block

Case 0:
'day
Temp = Day
Max_value = 31 : Gosub Input_value_ram : Day = Temp : Goto Display_fkt7

'month
Case 1:
Temp = Month
Max_value = 12 : Gosub Input_value_ram : Month = Temp : Goto Display_fkt7

'Eingabe Stunde
Case 2:
Temp = Hour
Max_value = 24 : Gosub Input_value_ram : Hour = Temp : Goto Display_fkt7

'Eingabe minute
Case 3:
Temp = Minute
Max_value = 60 : Gosub Input_value_ram : Minute = Temp : Goto Display_fkt7

''Input week_Day
'Case 4:
'Temp = Week_day
'Max_value = 60 : Gosub Input_value_ram : Week_day = Temp : Goto Display_fkt7

If Keyb > 1 Then Keyb = 0 : Goto Display_fkt7

End Select
Return

'######################### Input Data to EEPROM from Byte 101...; Input allways Integer ##############
Key8:
If Keyb <> 8 Then Goto Key9
Fkt8 = 1 : Lcd_param = &B00000001 : Gosub Lcd_writecmd      'Display lschen
If Data_pointer < 1 Or Data_pointer > 99 Then               '***change  Upper Limit Pointer
 Data_pointer = 1 : End If
Display_fkt8:
    Lcd_param = 1 : Gosub Lcd_gotoline
    Lcd_display_pad_with_spaces = 0
    Lcd_display_string = "Nr" : Gosub Lcd_display
        If Mobile_aktiv = 1 And Switch_input_block = 0 Then Gosub Write_fragez
    Value = Data_pointer : No_comma = 1 : Gosub Write_value
    Lcd_display_string = ":" : Gosub Lcd_display

'Value
 Temp_b1 = Data_pointer - 1 : Temp_b1 = Temp_b1 * 2 : Pointer_eeprom = Temp_b1 + 102

'#################### now comma ##########################
No_comma = 1
'If Data_pointer = xy Then no_comma = 0       'now check which values with comma or not
If Mobile_aktiv = 1 And Switch_input_block = 1 Then Gosub Write_fragez
 Readeeprom Value , Pointer_eeprom : Gosub Write_value

'###################### Unit ##########################
'Unit
Lcd_display_string = " "
If Data_pointer > 0 Then Lcd_display_string = " _"          '***change**** here you can give the Unit (C, V etc)
If Data_pointer = 1 Then
 Lcd_display_string = " sec"
 If Value > 100 Then Lcd_display_string = " min"
 If Value > 200 Then Lcd_display_string = " hr"
End If

'################### Display yes/no ##########################
'If Data_pointer = 2 Then
'      Lcd_display_string = " Nein(1/0)"
'         If Value = 1 Then Lcd_display_string = " Ja(0/1)"
'End If

Lcd_display_pad_with_spaces = 1 : Gosub Lcd_display

'########################## Info-Line in 2. Line ##########################
 Lcd_param = 2 : Gosub Lcd_gotoline
If Data_pointer = 1 Then
  Lcd_display_string = "Scan Time log"
  If Timer_2_sec = 0 Then Lcd_display_string = "<100=sec;>=min/h"
 End If
If Data_pointer = 2 Then Lcd_display_string = "1=Flash->Logview"

If Data_pointer = 3 Then Lcd_display_string = ""
If Data_pointer = 4 Then Lcd_display_string = ""
If Data_pointer = 5 Then Lcd_display_string = ""
If Data_pointer = 6 Then Lcd_display_string = ""
If Data_pointer = 7 Then Lcd_display_string = ""
If Data_pointer = 8 Then Lcd_display_string = ""
If Data_pointer = 9 Then Lcd_display_string = ""
If Data_pointer = 10 Then Lcd_display_string = ""
If Data_pointer = 11 Then Lcd_display_string = ""
If Data_pointer = 12 Then Lcd_display_string = ""
If Data_pointer = 13 Then Lcd_display_string = ""
If Data_pointer = 14 Then Lcd_display_string = ""
If Data_pointer = 15 Then Lcd_display_string = ""
If Data_pointer = 16 Then Lcd_display_string = ""
If Data_pointer = 17 Then Lcd_display_string = ""
If Data_pointer = 18 Then Lcd_display_string = ""
If Data_pointer = 19 Then Lcd_display_string = ""
If Data_pointer = 20 Then Lcd_display_string = ""
If Data_pointer = 21 Then Lcd_display_string = ""
If Data_pointer = 22 Then Lcd_display_string = ""

Lcd_display_pad_with_spaces = 1 : Gosub Lcd_display

End_display_fkt8:
Lcd_param = &B00001111 : Gosub Lcd_writecmd                 'Cursor flashin
Lcd_param = &H82
If Switch_input_block = 1 Then Lcd_param = &H85             'Cursor on position x Nr 12:xx
Gosub Lcd_writecmd
Gosub Line_feed
Return

'Value-Nr
Eing_8:
No_data_lcd_in_sec_loop = 1                                 'for LCD-character no jam

Select Case Switch_input_block
Case 0:
If Keyb = 11 Then
  Incr Switch_input_block : Stelle_1 = 0 : Negative_number = 0
  Goto Display_fkt8
End If

If Keyb = 0 And Stelle_1 = 0 Then
  Incr Data_pointer : Goto Display_fkt8 : End If

If Stelle_1 = 0 Then
     Data_pointer = Keyb : Stelle_1 = 1 : Goto Display_fkt8 : End If       '1.Digit

Data_pointer = 10 * Data_pointer : Data_pointer = Data_pointer + Keyb : Stelle_1 = 0
Goto Display_fkt8

'//////////////////// now Value  /////////////////////////////////
Case 1:
If Keyb = 11 Then
 Incr Switch_input_block : If Switch_input_block > 1 Then Switch_input_block = 0 : Stelle_1 = 0 : Negative_number = 0 : Goto Display_fkt8 : End If

Temp_b1 = Data_pointer - 1 : Temp_b1 = Temp_b1 * 2 : Pointer_eeprom = Temp_b1 + 102       'Data-Pointer start with Data at 102

If Stelle_1 = 0 Then
 Value = Keyb : Writeeeprom Value , Pointer_eeprom
 Stelle_1 = 1
 Goto Display_fkt8
End If

Readeeprom Value , Pointer_eeprom : Value = 10 * Value : Value = Value + Keyb : Writeeeprom Value , Pointer_eeprom
Goto Display_fkt8

End Select
Return

'############################# Submenu 9 Manual Mode #####################
Key9:
If Keyb <> 9 Then Return
Display_output_reset:
Disp_fkt9 = 1 : Gosub Reset_display
Display_output:
Lcd_param = 1 : Gosub Lcd_gotoline                          '1.Zeile anw.
If Display_info < 2 And Display_submenues = 0 Then          '
  Lcd_display_string = "Ausg.1/Tast1-8" : Gosub Write_manual_line_2 : Return : End If

Lcd_display_string = "1L1" : If Relay_1 = 1 Then Gosub Show_on Else Gosub Show_off
Lcd_display_string = "2R2" : If Relay_2 = 1 Then Gosub Show_on Else Gosub Show_off
Lcd_display_string = "3R3" : If Relay_3 = 1 Then Gosub Show_on Else Gosub Show_off
Lcd_display_string = "4R4" : If Relay_4 = 1 Then Gosub Show_on Else Gosub Show_off
Gosub Delete_rest_of_display

Lcd_param = 2 : Gosub Lcd_gotoline
Lcd_display_string = "5R5" : If Relay_5 = 1 Then Gosub Show_on Else Gosub Show_off
Lcd_display_string = "6R6" : If Relay_6 = 1 Then Gosub Show_on Else Gosub Show_off
Lcd_display_string = "7R7" : If Relay_7 = 1 Then Gosub Show_on Else Gosub Show_off
Lcd_display_string = "8Be" : If Beeper = 1 Then Gosub Show_on Else Gosub Show_off
Gosub Line_feed                                             'for Display on PC
Return

Display_fkt9_2:
'If Fkt9 = 0 Then Gosub Relais_management                    '22.8.08
Lcd_param = 1 : Gosub Lcd_gotoline                          '1.Zeile anw.
If Display_info < 2 Then
 Lcd_display_string = "Ausg.2/Tast1-8" : Gosub Write_manual_line_2 : Return : End If
Lcd_param = 1 : Gosub Lcd_gotoline
Lcd_display_string = "1L9" : If Output_9 = 1 Then Gosub Show_on Else Gosub Show_off
Lcd_display_string = "L10" : If Output_10 = 1 Then Gosub Show_on Else Gosub Show_off
Lcd_display_string = "L11" : If Output_11 = 1 Then Gosub Show_on Else Gosub Show_off
Lcd_display_string = "L12" : If Output_12 = 1 Then Gosub Show_on Else Gosub Show_off
Gosub Delete_rest_of_display

Lcd_param = 2 : Gosub Lcd_gotoline
Lcd_display_string = "L13" : If Output_13 = 1 Then Gosub Show_on Else Gosub Show_off
Lcd_display_string = "L14" : If Output_14 = 1 Then Gosub Show_on Else Gosub Show_off
Lcd_display_string = "7Ni" : If Nimh_load_rel = 1 Then Gosub Show_on Else Gosub Show_off
Lcd_display_string = "8PW" : If Pwm_port = 1 Then Gosub Show_on Else Gosub Show_off
Gosub Line_feed                                             'for Display on PC
Return

'Analog Inputs
Display_fkt9a:
 If Mobile_aktiv = 1 Then Print "Analog 1: ";
    Lcd_param = 1 : Gosub Lcd_gotoline                      '1.Zeile anw.
If Display_info < 2 Then
 Lcd_display_string = "Analog Gr.1  " : Gosub Write_manual_line_2 : Return : End If
Value = Getadc(0) : Gosub Display_analog_raw
Value = Getadc(1) : Gosub Display_analog_raw
Value = Getadc(2) : Gosub Display_analog_raw
Value = Getadc(3) : Gosub Display_analog_raw
Gosub Delete_rest_of_display

    Lcd_param = 2 : Gosub Lcd_gotoline                      '1.Zeile anw.
Value = Getadc(4) : Gosub Display_analog_raw
Value = Getadc(5) : Gosub Display_analog_raw
Value = Getadc(6) : Gosub Display_analog_raw
Value = Wahlschalter : Gosub Display_analog_raw
Gosub Delete_rest_of_display
Gosub Line_feed                                             'for Display on PC
Return

'Analog Inputs 2
Display_fkt9a2:
 If Mobile_aktiv = 1 Then Print "Analog 2: ";
 Lcd_param = 1 : Gosub Lcd_gotoline                         '1.Zeile anw.
If Display_info < 2 Then
 Lcd_display_string = "Analog Gr. 2  " : Gosub Write_manual_line_2 : Return : End If
 Value = Analog_9 : Gosub Display_analog_raw
Value = Analog_10 : Gosub Display_analog_raw
Value = Analog_11 : Gosub Display_analog_raw
Gosub Delete_rest_of_display

Lcd_param = 2 : Gosub Lcd_gotoline                          '1.Zeile anw.
Value = Analog_12 : Gosub Display_analog_raw
Value = Analog_13 : Gosub Display_analog_raw
Value = Analog_14 : Gosub Display_analog_raw
Value = Analog_15 : Gosub Display_analog_raw
Gosub Delete_rest_of_display
Gosub Line_feed                                             'for Display on PC
Return


Eing_9:
No_data_lcd_in_sec_loop = 1                                 'for LCD-character no jam
If Keyb <> 0 And Keyb <> 9 And Keyb <> 11 Then
Fkt9 = 1 : End If
If Keyb = 1 Then Toggle Relay_1
If Keyb = 2 Then Toggle Relay_2
If Keyb = 3 Then Toggle Relay_3
If Keyb = 4 Then Toggle Relay_4
If Keyb = 5 Then Toggle Relay_5
If Keyb = 6 Then Toggle Relay_6
If Keyb = 7 Then Toggle Relay_7
If Keyb = 8 Then Toggle Beeper
If Keyb = 0 Or Keyb = 11 Then
 Incr Display_submenues : If Display_submenues > 4 Then Display_submenues = 0 : Display_info = 0 : End If
Goto Display_output_reset

Eing_9_2:
No_data_lcd_in_sec_loop = 1                                 'for LCD-character no jam
If Keyb >= 1 And Keyb <= 8 Then Fkt9 = 1
If Keyb = 1 Then Toggle Output_9
If Keyb = 2 Then Toggle Output_10
If Keyb = 3 Then Toggle Output_11
If Keyb = 4 Then Toggle Output_12
If Keyb = 5 Then Toggle Output_13
If Keyb = 6 Then Toggle Output_14
If Keyb = 7 Then Toggle Pwm_port
If Keyb = 8 Then Toggle Nimh_load_rel
If Keyb = 0 Or Keyb = 11 Then
 Incr Display_submenues : If Display_submenues > 4 Then Display_submenues = 0 : Display_info = 0 : End If
Goto Display_fkt9_2

Write_manual_line_2:
Lcd_display_pad_with_spaces = 1 : Gosub Lcd_display : Lcd_param = 2 : Gosub Lcd_gotoline : Lcd_display_string = "weiter mit #" : Lcd_display_pad_with_spaces = 1 : Gosub Lcd_display : Incr Display_info : Gosub Line_feed       'for Display on PC : Return

Display_analog_raw:
No_comma = 1 : Gosub Write_value : Gosub Write_leerz
Return

Delete_rest_of_display:
Lcd_display_pad_with_spaces = 1 : Lcd_display_string = " " : Gosub Lcd_display
Return

'all Input
Display_fkt9b:
 Lcd_param = 1 : Gosub Lcd_gotoline                         '
If Display_info < 2 Then
 Lcd_display_string = "Digitale Eing." : Gosub Write_manual_line_2 : Return : End If

If Mobile_aktiv = 1 Then Print "DI:";
Lcd_display_string = "1"
If Input_1 = 1 Then Gosub Show_on Else Gosub Show_off

Lcd_display_string = "2"
If Input_2 = 1 Then Gosub Show_on Else Gosub Show_off

Lcd_display_string = "3" :
If Input_3 = 1 Then Gosub Show_on Else Gosub Show_off

Lcd_display_string = "4"
If Input_4 = 1 Then Gosub Show_on Else Gosub Show_off

Lcd_display_string = "5"
If Input_5 = 1 Then Gosub Show_on Else Gosub Show_off

Lcd_display_string = "6"
If Input_6 = 1 Then Gosub Show_on Else Gosub Show_off

Lcd_display_string = "7"
If Input_7 = 1 Then Gosub Show_on Else Gosub Show_off

Lcd_display_string = "8"
If Input_8 = 1 Then Gosub Show_on Else Gosub Show_off

Lcd_param = 2 : Gosub Lcd_gotoline                          '
 Lcd_display_string = "Zhler:" : Gosub Lcd_display
 Value = Counter_1 : No_comma = 1 : Gosub Write_value
Lcd_display_string = " " : Gosub Lcd_display
Timer1 = 0
Value = Counter_2 : No_comma = 1 : Gosub Write_value
Lcd_display_string = " " : Gosub Lcd_display
Timer3 = 0
Gosub Line_feed                                             'for Display on PC
Return


'##########  'with key "*" back to Basic-Menu ##########################

Reset:
Stelle_1 = 0
Reset_fkt:
Gosub Reset_display
Keyb = 255
Fkt1 = 0 : Fkt2 = 0 : Fkt3 = 0 : Fkt4 = 0 : Fkt5 = 0 : Fkt6 = 0 : Fkt7 = 0 : Fkt8 = 0 : Fkt9 = 0 : Disp_fkt9 = 0
Negative_number = 0 : Tel_nr = 0
If Mobile_aktiv = 0 Then Meldung_aktiv = 0 : Display_info = 0 : Switch_input_block = 0
Goto Grundmenue                                             'Funktionen aus und Ende

Input_value_ram:
If Keyb = 11 Then                                           'next Input-Block
   Keyb = 255 : Stelle_1 = 0 : Incr Switch_input_block : Return : End If
If Stelle_1 = 0 Then
  Temp = Keyb : Stelle_1 = 1 : Return : End If              '1.Digit
   Temp = 10 * Temp : Temp = Temp + Keyb
  If Max_value > 0 And Temp > Max_value Then                'Max-Value
    Temp = Keyb : Max_value = 0 : Stelle_1 = 1 : Return : End If       'Gosub Write_nein :
   Max_value = 0
Return

'################################ Load_flash_to_file_on_hd ############################################################
Load_flash_to_file_on_hd:
Lcd_param = 1 : Gosub Lcd_gotoline
 Lcd_display_string = "bitte warten..." : If English = 1 Then Lcd_display_string = "please wait..." : No_print_seriell = 1 : Gosub Lcd_display : Gosub Line_feed
Delay = 0
'Temp1 = start-adr; Temp2 = end-adr
For Pointer_eeprom = Temp1 To Temp2
Readeeprom Temp , Pointer_eeprom
Print Temp
Incr Pointer_eeprom
Waitms 260
Next
Print "End"
Wait 2                                                      'for to show data on Dialer
Return
'################################ Get_data_for_flash ############################################################
Get_data_for_flash:                                         'message-Text
Lcd_param = 1 : Gosub Lcd_gotoline
 Lcd_display_string = "bitte warten..." : If English = 1 Then Lcd_display_string = "please wait..." : Gosub Lcd_display : Gosub Line_feed
Delay = 0
'Dim loop_counter as Word
'Temp1 = start-adr; Temp2 = end-adr
'Waitms 300
'cli                                                         'Disable Interrupt
Temp = 0                                                    'Time-out
Temp_b3 = 0                                                 'number of Bytes
Pointer_eeprom = Temp1
Lcd_display_string = ""
For Pointer_eeprom = Temp1 To Temp2                         '368 Bytes 16*(15+8)
Loop_wait_inkey:
Remote_key = Inkey(#1)                                      'get it
 Temp = Temp + 1
Waitus 100
  If Temp > 32000 Then Goto Show_counter                    'Timeout
 If Remote_key = 0 Then
    Goto Loop_wait_inkey
Else                                                        'there is data
   If Remote_key > 47 And Remote_key < 58 Then
      Incr Temp_b3                                          'count sign
      Remote_key = Remote_key - 48 : S = Str(remote_key)
      Lcd_display_string = Lcd_display_string + S : Goto Loop_wait_inkey : End If
  If Remote_key = 10 Or Remote_key = 13 Then
     Value = Val(lcd_display_string)
     Writeeeprom Value , Pointer_eeprom : Incr Pointer_eeprom : Temp = 0 : Lcd_display_string = "" : Waitms 60 : End If       'cr
End If
Next

Show_counter:
'sei                                                         'Enable Interrupt
Lcd_param = 1 : Gosub Lcd_gotoline
Lcd_display_string = "not ok!" : If Temp_b3 > 40 Then Lcd_display_string = "ok!"
Lcd_display_pad_with_spaces = 1 : Gosub Lcd_display
Gosub Line_feed
Time_no_seriell_pc = 15
Wait 3
Return

Show_on:
Gosub Lcd_display
Lcd_param = Lcd_cursorblock : Gosub Lcd_writechar
'Lcd_display_string = "#" : Gosub Lcd_display
If Mobile_aktiv = 1 Then Print "# ";
Return

Show_off:
Gosub Lcd_display
Lcd_display_string = "." : Gosub Lcd_display
If Mobile_aktiv = 1 Then Print " ";
Return

Write_fragez:
If Mobile_aktiv = 0 Then Return
If Timer_1_sec = 0 Then Print " ?" ; Else Print "   " ;
Return

Show_blank:
If Timer_1_sec = 0 Then Lcd_display_string = " "
Return

Reset_display:
  Lcd_param = &B00001000 : Gosub Lcd_writecmd               'Display aus
Waitms 50
  Lcd_param = &B00101100 : Gosub Lcd_writecmd               ' Zeilen und Font einstellen
Waitms 50
  Lcd_param = &B00001100 : Gosub Lcd_writecmd               'Display an
Waitms 50
  Lcd_param = &B00000001 : Gosub Lcd_writecmd               'Reset Display
Waitms 50
  Lcd_param = &B00000110 : Gosub Lcd_writecmd               'Auto inkrement
Waitms 50
Return

'################################### Value to seriell #####################
Print_value:
If Mobile_aktiv = 0 And Sending_os_data_active = 0 And Send_flash_to_logview = 0 And Data_direct_to_pc = 0 Then Return

 If Value > 32767 Then                                      'negative?
   Print "-" ; : Value = 65536 - Value : End If

If Eight_bit_value_neg = 1 And Value > 128 Then
   Print "-" ; : Value = Value - 128 : End If

If Value > 10000 Then
 Print "1" ; : Goto Print_01 : End If                       '1
If Value > 20000 Then
 Print "2" ; : Goto Print_01 : End If                       '2
If Value > 30000 Then
 Print "3" ; : Goto Print_01 : End If                       '3

Print_01:
Temp = Value Mod 10000 : Temp = Temp / 1000                 'Tausender
If Value >= 1000 Then Print Temp;

Temp = Value Mod 1000 : Temp = Temp / 100 :                 'Hunderter
If Value >= 100 Then Print Temp;

If Tel_nr = 1 Then Goto Print_eine_ziffer
Temp = Value Mod 100 : Temp = Temp / 10
If Two_comma = 1 Then Print "," ;
If Display_time_grid = 1 And Value > 100 Then Print "," ;

If Value >= 10 Then Print Temp;
Goto P03

Print_eine_ziffer:
Temp = Value Mod 100 : Temp = Temp / 10

If Value >= 10 Then Print Temp;
P03:
If No_comma = 0 And Two_comma = 0 Then
  If Value = 0 Then Print "0";
  Print "," ; : End If

Temp = Value Mod 10                                         'einer Dezimalstelle ohne Leerzeichen
 Print Temp;
If Tel_nr = 0 And Data_direct_to_pc = 0 And Send_flash_to_logview = 0 Then Print " ";
Return

Send_value_to_serial:
Gosub Print_value : If Vb_process_display = 1 And Data_direct_to_pc = 0 Then Print "" : If Data_direct_to_pc = 1 Then Print ";" ; : If Last_value = 1 Then Print "0" ; : Last_value = 0
Return

'#######################  LCD_Initialisierung #######################
Lcd_init:
Porta = 0 : Portc.0 = 0 : Portc.1 = 0 : Portc.5 = 0
Config Porta = Output : Config Pinc.0 = Output : Config Pinc.1 = Output : Config Pinc.5 = Output
Waitms 400
  Porta = &B00000010 : Portc.5 = 1 : Waitms 5 : Portc.5 = 0 'mit 8-Bit-Command in 4-Bit-Modus umschalten
Waitms 50
Gosub Reset_display

 Lcd_param = 1 : Gosub Lcd_gotoline                         '2.Line LCD anw.
 If Simu = 1 Then
   Lcd_display_string = "   Simu Mode!" : Lcd_display_pad_with_spaces = 1 : Gosub Lcd_display : Gosub Line_feed       'for Display on PC : Waitms 600
End If

Lcd_display_string = Start_test : Gosub Lcd_display : Gosub Line_feed
Lcd_param = 2 : Gosub Lcd_gotoline
Lcd_display_string = Version_data : Gosub Lcd_display : Gosub Line_feed
 Return

Write_value:
If Mobile_aktiv = 1 Then Gosub Print_value
'negative value?
'If Data_pointer = 39 Then
'If Eight_bit_value_neg = 1 And Value > 128 Then
'   Lcd_param = Minus : Gosub Lcd_writechar : Value = Value - 128 : End If
'Eight_bit_value_neg = 0
'
'If Value > 32767 Then                                       'negative?
'   Lcd_param = Minus : Gosub Lcd_writechar : Value = 65536 - Value : End If
'End If

If Value > 10000 Then Lcd_param = &H31                      '1
If Value > 20000 Then Lcd_param = &H32                      '2
If Value > 30000 Then Lcd_param = &H33                      '2
If Value > 40000 Then Lcd_param = &H34                      '2
If Value > 50000 Then Lcd_param = &H35                      '2
If Value > 60000 Then Lcd_param = &H36                      '2
If Value > 10000 Then Gosub Lcd_writechar
Temp = Value Mod 10000 : Temp = Temp / 1000 : Temp2 = Value
If Temp2 >= 1000 Then Lcd_param = Null + Temp Else Goto W01 ' Tausender-Dezimalstelle
Gosub Lcd_writechar
W01:
Temp = Value Mod 1000 : Temp = Temp / 100 : Temp2 = Value
If Temp2 >= 100 Then Lcd_param = Null + Temp Else Goto W02  ' Hunderter-Dezimalstelle
Gosub Lcd_writechar
W02:
If Tel_nr = 1 Then Goto Eine_ziffer
Temp = Value Mod 100 : Temp = Temp / 10 : Temp2 = Value
If Two_comma = 1 Or Display_time_grid = 1 Then
 If Display_time_grid = 0 Or Value >= 100 Then
  Lcd_param = Punkt : Gosub Lcd_writechar : End If
End If
If Temp2 >= 10 Then Lcd_param = Null + Temp Else Lcd_param = Null       ' Zehner-Dezimalstelle mit einer fhrenden 0
Gosub Lcd_writechar
Goto W03

Eine_ziffer:
Temp = Value Mod 100 : Temp = Temp / 10 : Temp2 = Value
If Temp2 >= 10 Then Lcd_param = Null + Temp Else Goto W03   ' Zehner-Dezimalstelle ohne eine fhrenden 0 fr Tel-Nr
Gosub Lcd_writechar
W03:
If No_comma = 0 And Two_comma = 0 Then
  Lcd_param = Punkt : Gosub Lcd_writechar : End If
Temp = Value Mod 10
Lcd_param = Null + Temp                                     ' einer Dezimalstelle ohne Leerzeichen
Gosub Lcd_writechar
Tel_nr = 0 : No_comma = 0 : Two_comma = 0 : Display_time_grid = 0
Return

'goto line
Lcd_gotoline:
If Lcd_param = 2 And Mobile_aktiv = 1 And No_print_seriell = 0 Then Print " ";
If Lcd_param = 1 Then Lcd_param = &H80 : If Lcd_param = 2 Then Lcd_param = &HC0       'Code fr Zeile

' LCD-command
Lcd_writecmd:
  Portc.0 = 0 : Goto Lcd_write                              'lcd_rs

' Zeichenausgabe
Lcd_writechar:
Portc.0 = 1                                                 '  lcd_rs

' Kommando oder Zeichen an Display senden
Lcd_write:
Temp_lcd = Lcd_param : Shift Temp_lcd , Right , 4
  Porta = Temp_lcd : Portc.5 = 1 : Waitms 3 : Portc.5 = 0   ' Hi-Nibble
  Porta = Lcd_param And &H0F : Portc.5 = 1 : Waitms 3 : Portc.5 = 0       ' Lo-Nibble
  Porta = 0 : Portc.6 = 0 : Portc.0 = 0                     'da eventuell gesetzt
  Return

Lcd_display:
  If Len(lcd_display_string) = 0 Then Return
  If Mobile_aktiv = 1 And No_print_seriell = 0 Then Print Lcd_display_string ; : No_print_seriell = 0
  'pad with spaces...
  If Lcd_display_pad_with_spaces = 1 Then
      'add spaces to the right of the string passed in to make it 16 chars long...
       Temp_b4 = Len(lcd_display_string)
       If Temp_b4 <= 16 Then
          Temp_b4 = 16 - Temp_b4
          For Temp_b3 = 1 To Temp_b4
             Lcd_display_string = Lcd_display_string + " "
          Next
          End If
  End If

Lcd_display_pad_with_spaces = 0

  'actually display value...
  For Lcd_display_position = 1 To Len(lcd_display_string)
      Lcd_disp_char = Mid(lcd_display_string , Lcd_display_position , 1)       'Lcd_display_position )       'Lcd_display_position

        If Lcd_disp_char = "" Then Lcd_param = &HEF
        If Lcd_disp_char = "" Then Lcd_param = &HE1
        If Lcd_disp_char = "" Then Lcd_param = &HF5
        If Lcd_disp_char = "" Then Lcd_param = &HDF
        If Lcd_disp_char = "-" Then Lcd_param = Char_minus
        If Lcd_disp_char <> "" And Lcd_disp_char <> "" And Lcd_disp_char <> "" And Lcd_disp_char <> "" And Lcd_disp_char <> "-" Then
        Lcd_param = Asc(lcd_disp_char)
   End If
   Gosub Lcd_writechar
   Next
Return

'Leerzeichen schreiben
Write_leerz:
Lcd_param = Leerz : Gosub Lcd_writechar : Return

Line_feed:
If Mobile_aktiv = 1 Then Print " "
Return

'###################### Prog-Switch #####################
Program_switch:
If Wahlschalter > 4 Then Goto Prg2                          'Programm_selector
Programm_selector = 1 : Return                              ': Return
Prg2:
If Wahlschalter > 28 Then Goto Prg3                         'Programm_selector
Programm_selector = 2 : Return
Prg3:
If Wahlschalter > 34 Then Goto Prg4                         'Programm_selector
Programm_selector = 3 : Return
Prg4:
If Wahlschalter > 46 Then Goto Prg5                         'Programm_selector
Programm_selector = 4 : Return
Prg5:
If Wahlschalter > 61 Then Goto Prg6                         'Programm_selector
Programm_selector = 5 : Return
Prg6:
If Wahlschalter > 103 Then Goto Prg7                        'Programm_selector
Programm_selector = 6 : Return
Prg7:
If Wahlschalter > 130 Then Goto Prg8                        'Programm_selector
Programm_selector = 7 : Return
Prg8:
If Wahlschalter > 166 Then Goto Prg9                        'Programm_selector
Programm_selector = 8 : Return
Prg9:
If Wahlschalter > 194 Then Goto Prg10                       'Programm_selector
Programm_selector = 9 : Return
Prg10:
If Wahlschalter > 224 Then Goto Prg11                       'Programm_selector
Programm_selector = 10 : Return
Prg11:
If Wahlschalter > 246 Then Goto Prg12                       'Programm_selector
Programm_selector = 11 : Return
Prg12:
Programm_selector = 12 : Return

'######################### keyboard ################################
Tastatur_input:
Next_check:
Debounce Pina.0 , 1 , Port1
Debounce Pina.1 , 1 , Port2
Debounce Pina.2 , 1 , Port3
Debounce Pina.3 , 1 , Port4
Debounce Pina.4 , 1 , Port5
Debounce Pina.5 , 1 , Port6
Debounce Pina.6 , 1 , Port7
Debounce Pina.7 , 1 , Port8
Debounce Pinc.0 , 1 , Lcd_rs
Debounce Pinc.1 , 1 , Lcd_rw
Debounce Pinc.2 , 1 , Port11
Debounce Pinc.3 , 1 , Port12
Goto Input_end
Port1:
Port1 = 1 : Goto Input_end
Port2:
Port2 = 1 : Goto Input_end
Port3:
Port3 = 1 : Goto Input_end
Port4:
Port4 = 1 : Goto Input_end
Port5:
Port5 = 1 : Goto Input_end
Port6:
Port6 = 1 : Goto Input_end
Port7:
Port7 = 1 : Goto Input_end
Port8:
Port8 = 1 : Goto Input_end
Lcd_rs:
Lcd_rs = 1 : Goto Input_end
Lcd_rw:
Lcd_rw = 1 : Goto Input_end
Port11:
Port11 = 1 : Goto Input_end
Port12:
Port12 = 1
Input_end:
Portc.4 = 0                                                 'Tastatur inaktiv setzen
Porta = 0                                                   'set all 0
Portc.0 = 0                                                 'Tastatur inaktiv setzen
Portc.1 = 0                                                 'Tastatur inaktiv setzen
Portc.2 = 0                                                 'Tastatur inaktiv setzen
Portc.3 = 0                                                 'Tastatur inaktiv setzen
Config Porta = Output : Config Portc = Output
Return

Pullups:
Porta.0 = 1
Config Pina.0 = Input
Porta.1 = 1
Config Pina.1 = Input
Porta.2 = 1
Config Pina.2 = Input
Porta.3 = 1
Config Pina.3 = Input
Porta.4 = 1
Config Pina.4 = Input
Porta.5 = 1
Config Pina.5 = Input
Porta.6 = 1
Config Pina.6 = Input
Porta.7 = 1
Config Pina.7 = Input
Portc.0 = 1
Config Pinc.0 = Input
Portc.1 = 1
Config Pinc.1 = Input
Portc.2 = 1
Config Pinc.2 = Input
Portc.3 = 1
Config Pinc.3 = Input
Return

'########################## Analog 8-15 ########################
'MUX = PB2, PD4, PD5
Analog_extended:
Gosub_analog_extended = 0
'Start Adc
Incr Analog_block : If Analog_block < 0 Or Analog_block > 7 Then Analog_block = 0

If Analog_block = 0 Then
 Temp = Getadc(7) / 4 : Wahlschalter = Temp
 Portb.2 = 1 : Portd.4 = 0 : Portd.5 = 0 : Return : End If

If Analog_block = 1 Then
 Analog_9 = Getadc(7)
 Portb.2 = 0 : Portd.4 = 1 : Portd.5 = 0 : Return : End If

If Analog_block = 2 Then
 Analog_10 = Getadc(7)
 Portb.2 = 1 : Portd.4 = 1 : Portd.5 = 0 : Return : End If

If Analog_block = 3 Then
 Analog_11 = Getadc(7)
 Portb.2 = 0 : Portd.4 = 0 : Portd.5 = 1 : Return : End If

If Analog_block = 4 Then
 Analog_12 = Getadc(7)
 Portb.2 = 1 : Portd.4 = 0 : Portd.5 = 1 : Return : End If

If Analog_block = 5 Then
 Analog_13 = Getadc(7)
 Portb.2 = 0 : Portd.4 = 1 : Portd.5 = 1 : Return : End If

 If Analog_block = 6 Then
 Analog_14 = Getadc(7)
 Portb.2 = 1 : Portd.4 = 1 : Portd.5 = 1 : Return : End If

 If Analog_block = 7 Then
 Analog_15 = Getadc(7)
 Portb.2 = 0 : Portd.4 = 0 : Portd.5 = 0 : Return : End If
Return

'####################### read digital Input ##############################
Eingaenge:
Porta = 0 : Portc.3 = 0
Config Porta = Input
Config Pinc.3 = Output : Portc.3 = 1                        'Eingnge Port 12 aktiv setzen
Waitms 50
Input_1 = Pina.0 : Input_2 = Pina.1 : Input_3 = Pina.2 : Input_4 = Pina.3 : Input_5 = Pina.4 : Input_6 = Pina.5 : Input_7 = Pina.6 : Input_8 = Pina.7
Portc.3 = 0 : Config Pinc.3 = Input                         'Eingnge Port 12 inaktiv setzen
If Simu = 1 Then
 If U_ausg < 128 Then
   Input_1 = 0 : Input_2 = 0 : Input_3 = 0 : Input_4 = 0 : Input_5 = 0 : Input_6 = 0 : Input_7 = 0 : Input_8 = 0
  Else
  Input_1 = 1 : Input_2 = 1 : Input_3 = 1 : Input_4 = 1 : Input_5 = 1 : Input_6 = 1 : Input_7 = 1 : Input_8 = 1
  End If
End If
Porta = 0                                                   'set all 0
Return

'####################### Analog Values #################################
Analog_werte:
Ad1 = Getadc(0)
Ad2 = Getadc(1)
Ad3 = Getadc(2)
Ad4 = Getadc(3)
Ad5 = Getadc(4)
Ad6 = Getadc(5)
Ad7 = Getadc(6)
Ad8 = Getadc(7)
Return

'####################### Output to Hardware #################################
Output:
Lcd_port = 0
Config Porta = Output
Porta.0 = Relay_1
Porta.1 = Relay_2                                           'Relay 7 Port 2
Porta.2 = Relay_3                                           'Relay Batt leer Port3
Porta.3 = Relay_4                                           'Relay 2 Port4
Porta.4 = Relay_5                                           'Relay 3 Port5
Porta.5 = Relay_6                                           'Relay 4 Port 6
Porta.6 = Relay_7                                           'vorher ext.Hupe Relay 5 Port 7
Porta.7 = Beeper
Config Pinc.6 = Output
Portc.6 = 1 : Waitms 20 : Portc.6 = 0                       'bergabe an HC573
Porta = 0
Return

Reset_outputs:
If Fkt9 = 1 Then Return                                     'Manual mode
Relay_1 = 0
Relay_2 = 0                                                 'Reset if no Manual Mode
Relay_3 = 0                                                 'Reset if no Manual Mode
Relay_4 = 0
Relay_5 = 0
Relay_6 = 0
Relay_7 = 0
Beeper = 0

Output_9 = 0
Output_10 = 0
Output_11 = 0
Output_12 = 0
Output_13 = 0
Output_14 = 0
Nimh_load_rel = 0
Return

'####################### Counter #########################
Counter_fast:
Counter_1 = Counter_1 + Timer1 : Timer1 = 0
Counter_2 = Counter_2 + Timer3 : Timer3 = 0
Return

'##################### Timer0 for Time-slices and Time #############################
Tim0_isr:                                                   'triggered by Timer 0; don't delete
Incr M_second
If M_second = 1 Or M_second = 15 Or M_second = 30 Or M_second = 45 Then Gosub_analog_extended = 1
If M_second > 60 Then                                       '60     *255/ 21                              '4 Mhz: mit Teiler 256:61
  Incr Second : M_second = 0 : End If
Return

Time_date:
If Day = 0 Then Day = 1
If Second > 60 Then
 Incr Minute : Incr Minute_byte : If Minute_byte = 0 Then Minute_byte = 1 : Second = 1 : If Day = 0 Then Day = 1 : Sec_alt = Second : End If
If Minute > 59 Then
 Incr Hour : Minute = 0 : End If
If Week_day = 0 Or Week_day > 7 Then Week_day = 1
If Hour > 23 Then
 Incr Week_day
 Incr Day : Hour = 0 : End If
  If Day > 28 Then
     Select Case Month
        Case 1 : Mday = 31
        Case 2 : Mday = Year And &H03
           If Mday = 0 Then
              Mday = 29
           Else
              Mday = 28
           End If
        Case 3 : Mday = 31
        Case 4 : Mday = 30
        Case 5 : Mday = 31
        Case 6 : Mday = 30
        Case 7 : Mday = 31
        Case 8 : Mday = 31
        Case 9 : Mday = 30
        Case 10 : Mday = 31
        Case 11 : Mday = 30
        Case 12 : Mday = 31
     End Select
     If Day > Mday Then
        Day = Day - Mday : Incr Month
        If Month > 12 Then
           Month = 1 : Incr Year
        End If
     End If
  End If
Return

End